﻿using System.Collections.Generic;
using System.Collections.Specialized;
using System.Linq;
using System.Net;
using System.Text;

namespace Mobile.Search.Shared.Extensions
{
    public static class QueryStringExtensions
    {
        public static string ToQueryString(this IDictionary<string, string> dict)
        {
            if (dict.Count == 0) return string.Empty;

            var buffer = new StringBuilder();
            int count = 0;
            bool end = false;

            foreach (var key in dict.Keys)
            {
                if (count == dict.Count - 1) end = true;

                var value = dict[key];
                // if there's amperstamp in the value then we must have to encode it
                if (dict[key].Contains("&"))
                {
                    value = WebUtility.UrlEncode(value);
                }

                if (end)
                    buffer.AppendFormat("{0}={1}", key, value);
                else
                    buffer.AppendFormat("{0}={1}&", key, value);

                count++;
            }

            return buffer.ToString();
        }

        public static Dictionary<string, string> ToDictionary(this NameValueCollection nvc)
        {
            return nvc.AllKeys.Where(q => !string.IsNullOrEmpty(q) && !string.IsNullOrEmpty(nvc[q])).ToDictionary(k => k, k => nvc[k]);
        }
    }
}