﻿using System;
using System.Web;
using Serilog;
using System.Collections.Generic;

namespace Mobile.Search.Shared.Models
{
    public class Listing
    {
        public int Rank { get; set; } 
        public string Title { get; set; }
        public string Description { get; set; }
        public string SiteHost { get; set; }
        public bool BiddedListing { get; set; }
        public string ResultType { get; set; }
        public string SiteLanguage { get; set; }
        public string ListingLanguage { get; set; }
        public string PhoneNumber { get; set; }
        public string ClickUrl { get; set; }
        public string FaviconUrl { get; set; }
        public string MerchRatingNumber { get; set; }
        public string MerchRatingUrl { get; set; }
        public string LongTitle { get; set; }
        public string ThumbnailImageUrl { get; set; }
        public string ImageUrl { get; set; }
        public List<String> Categories { get; set; }

        // === Yahoo! API Extensions Update 2017-10-11 === //

        // 1. Callout Extensions
        public string CalloutAnnotation { get; set; }

        // 2. Review Extensions
        public string ReviewSource { get; set; }
        public string ReviewText { get; set; }

        // 3. 4th Line Annotations
        public string Ad4thLine { get; set; }

        // 4. Top Ad Annotations
        public string HasTopAdAnnotation { get; set; }
        public string TopAdDomain { get; set; }
        public string TopAdClicks { get; set; }

        // 5. Security Badge
        public string SecurityProvider { get; set; }

        // 6. Brand Annotations
        public string AdOfficialBrand { get; set; }

        // 7. Smart Ad Annotations
        public string SmartAdAnnotation { get; set; }


        public List<SiteLink> SiteLinks { get; set; }

        public string GetTitle()
        {
            if (string.IsNullOrEmpty(Title))
            {
                return string.Empty;
            }

            else
            {
                return Title;
            }
        }

        public string GetAdvertiserUrl()
        {
            if (string.IsNullOrEmpty(ClickUrl))
            {
                return string.Empty;
            }
            try
            {
                var clickUri = new Uri(ClickUrl);
                return HttpUtility.ParseQueryString(clickUri.Query).Get("u") ?? string.Empty;
            }
            catch (UriFormatException formatException)
            {
                Log.Error(formatException, "Not a valid url format {clickurl}", ClickUrl);
                return string.Empty;
            }
        }

        public class SiteLink
        {
            public string Text { get; set; }
            public string Url { get; set; }
        }
    }
}