﻿using System;
using System.Collections.Generic;
using System.Runtime.Serialization;

namespace Mobile.Search.Shared.Models
{
    public class PartialSearchResult : SearchResult
    {
        public int ListingNumber { get; set; }
    }
    public class SearchResult
    {

        public SearchResult()
        {
            // Default the ClickUrl func to return the click url 
            // with no modifications until we get a tracking link
            ClickUrlFunc = listing => listing.ClickUrl;
        }
        public string Query { get; set; }

        [IgnoreDataMember]
        public IEnumerable<Listing> Listings { get; set; }
        public int ListingsCount { get; set; }
        public string Ip { get; set; }
        public string UserAgent { get; set; }
        public List<string> RelatedSearches { get; set; }
        public string SourceTag { get; set; }
        public string TypeTag { get; set; }
        public Guid SearchId { get; set; }
        public string OriginalQuery { get; set; }
        public string sourceUrl { get; set; }
        public string userReferrer { get; set; }
        public string utmCampaign { get; set; }

        [IgnoreDataMember]
        public Func<Listing, string> ClickUrlFunc { get; set; }
        public string NextUrl { get; set; }
    }
}