﻿using System.Collections.Generic;

namespace Mobile.Search.Shared
{
    public class YahooTags
    {
        public static readonly Dictionary<int, string> SourceTagDictionary = new Dictionary<int, string>
        {
            {1, "adknowledge_mobile_2click_c_search" },
            {2, "adknowledge_mobile_1click_c_search"},
            {3, "adknowledge_d2s_gocomics_search"},
            {4, "adknowledge_mobile_1click_search"},
            {5, "adknowledge_mobile_2click_newsletter_search"},
            {6, "adknowledge_mobile_1click_d_search"},
            {7, "adknowledge_mobile_1click_e_search"},
            {8, "adknowledge_mobile_2click_e_search"},
            {9, "adknowledge_mobile_1click_f_search"},
            {10, "adknowledge_mobile_2click_f_search"},
            {11, "adknowledge_mobile_2click_d_search"},
            {12, "adknowledge_mobile_2click_j_search"},
            {13, "adknowledge_mobile_2click_k_search"},
            {14, "adknowledge_mobile_1click_k_search"},
        };
        public static string CleanTypeTag(string typeTag)
        {
            return string.IsNullOrEmpty(typeTag) 
                ? typeTag 
                : System.Net.WebUtility.UrlDecode(typeTag).Replace(" ", "+");
        }

        public static string GetSourceTag(int type)
        {
            if (SourceTagDictionary.ContainsKey(type))
            {
                return SourceTagDictionary[type];
            }
            else
            {
                // this shouldn't be the default, but i don't know what relies on this
                // so won't change it
                return SourceTagDictionary[2];
            }
        }
    }
}