﻿using System.Web;
using System.Web.Mvc;
using Serilog;

namespace Mobile.Search.Web
{
    public class FilterConfig
    {
        public static void RegisterGlobalFilters(GlobalFilterCollection filters)
        {
            filters.Add(new LogExceptionFilter());
            filters.Add(new HandleErrorAttribute());
        }
    }

    public class LogExceptionFilter : IExceptionFilter
    {
        public void OnException(ExceptionContext filterContext)
        {
            var exception = filterContext.Exception;
            Log.Error(exception, "Unhandled Error in MobSearch");
        }
    }
}
