﻿using Microsoft.AspNet.Identity;
using Microsoft.Owin.Security;
using Microsoft.Owin.Security.Cookies;
using Microsoft.Owin.Security.OpenIdConnect;
using Mobile.Search.Web.Helpers;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Security.Claims;
using System.Web;
using System.Web.Mvc;
using System.Web.Security;

namespace Mobile.Search.Web.Controllers
{
    public class AccountController : Controller
    {

        public void SignIn()
        {
            // Send an OpenID Connect sign-in request.
            if (!Request.IsAuthenticated)
            {
                HttpContext.GetOwinContext().Authentication.Challenge(new AuthenticationProperties { RedirectUri = "/home" },
                    OpenIdConnectAuthenticationDefaults.AuthenticationType);
            }

        }

        public ActionResult LogIn()
        {
            return View();
        }

        [HttpPost]
        public ActionResult Login(string username, string password)
        {
            if ((username == "Partner" && password == "ReachMoney!"))
            {
                HttpContext.GetOwinContext().Authentication
                  .SignOut(DefaultAuthenticationTypes.ExternalCookie);

                Claim claim1 = new Claim(ClaimTypes.Name, username);
                Claim[] claims = new Claim[] { claim1 };
                ClaimsIdentity claimsIdentity =
                  new ClaimsIdentity(claims,
                    DefaultAuthenticationTypes.ApplicationCookie);

                HttpContext.GetOwinContext().Authentication
                 .SignIn(new AuthenticationProperties() { IsPersistent = false }, claimsIdentity);

                var returnUrl = "/Home";
                return Redirect(returnUrl);
            }
            else
            {
                ModelState.AddModelError("",
                 "Invalid username or password.");
            }

            return View();
        }

        public ActionResult Logout()
        {
            HttpContext.GetOwinContext().Authentication
               .SignOut();
            return RedirectToAction("Index", "Home");
        }

        public void SignOut()
        {
            //partner sign out
            if (RequestHelper.GetUserName(User).ToString().Equals("Partner"))
            {
                HttpContext.GetOwinContext().Authentication
              .SignOut();
                RedirectToAction("Index", "Home");

            }
            else
            {
                string callbackUrl = Url.Action("SignOutCallback", "Account", routeValues: null, protocol: Request.Url.Scheme);

                HttpContext.GetOwinContext().Authentication.SignOut(
                    new AuthenticationProperties { RedirectUri = callbackUrl },
                    OpenIdConnectAuthenticationDefaults.AuthenticationType, CookieAuthenticationDefaults.AuthenticationType);
            }
        }

        public ActionResult SignOutCallback()
        {
            if (Request.IsAuthenticated)
            {
                // Redirect to home page if the user is authenticated.
                return RedirectToAction("Index", "Home");
            }

            return View();
        }

    }
}