﻿using System;
using System.Collections.Generic;
using System.Web.Mvc;
using Mobile.Search.Providers;
using Mobile.Search.Shared;
using Serilog;

namespace Mobile.Search.Web.Controllers
{
    public class BidSystemController : Controller
    {
        // GET: BidSystem
        public ActionResult Index()
        {
            return View();
        }


        public JsonResult ClickUrl(int? categoryId, string listId, string sessionId, string ip, string ua,
            string quizId, string questionId, string answerId, string userId, string questionStackId, long? publisherId, string subPublisher, int? sequence)
        {
            var searchqueryid = Guid.NewGuid().ToString();
            var affiliateid = default(string);

            // override quiz ids quick hack
            if (!string.IsNullOrEmpty(quizId) && (quizId == "137" || quizId == "103" || quizId == "134" || quizId == "140" || quizId == "141" || quizId == "10141"))
            {
                affiliateid = "844469";
            }
            else
            {
                affiliateid = "844069";
            }


            var clickUrl = BidSystemProvider.GetClickUrl(searchqueryid, categoryId.ToString(), ip, affiliateid);
            try
            {

                Tracker.TrackBidSystemSearch(new Dictionary<string, string>
                {
                    {"timestamp", DateTime.UtcNow.ToString("O")},
                    {"listid", listId},
                    {"searchqueryid", searchqueryid},
                    {"categoryid", categoryId.ToString()},
                    {"sessionid", sessionId},
                    {"affiliateid", affiliateid},
                    {"ip", ip},
                    {"ua", ua},
                    {"quizid", quizId},
                    {"questionid", questionId},
                    {"answerid", answerId},
                    {"userid", userId},
                    {"publisherid", string.Format("{0}", publisherId)},
                    {"subpublisher", subPublisher},
                    {"sequence", string.Format("{0}", sequence)},
                    {"questionstackid", questionStackId},
                    {"clickurl", clickUrl},
                });
            }
            catch (Exception x)
            {
                Log.Error(x, "Error queueing bidsystem search");
            }

            return Json(new
            {
                clickUrl = clickUrl
            }, JsonRequestBehavior.AllowGet);
        }
    }
}