﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Mobile.Search.Providers;
using Mobile.Search.Shared;
using Mobile.Search.Shared.Models;
using Mobile.Search.Web.Extensions;
using Mobile.Search.Web.Helpers;
using ServiceStack;

namespace Mobile.Search.Web.Controllers
{
    public class DesktopController : Controller
    {
        private static readonly SearchUrlHelper UrlHelper = new SearchUrlHelper();

        // GET: Desktop
        public JsonResult Json(string sourceTag, string query, string serveUrl = null, int resultCount = 5, string ip = null, string userAgent = null, string subpub = null, bool redirect = false)
        {

            var searchRequest = new SearchRequest
            {
                BiddedResults = resultCount,
                Ip = ip ?? RequestHelper.GetIp(HttpContext),
                NonBiddedResults = 0,
                Query = query,
                ServeUrl = serveUrl ?? UrlHelper.GetAuthority(Request) + "/search",
                SourceTag = sourceTag,
                TypeTag = "subpub:" + (subpub ?? "") + "_kw:" + query.Replace(" ", "+"),
                UseFakeUserAgent = false,
                UserAgent = userAgent ?? Request.UserAgent
            };
            var searchResult = YahooProvider.GetListings(searchRequest);
            if (redirect)
            {
                searchRequest.ServeUrl = UrlHelper.GetAuthority(Request) + "/search/R";
            }
            searchResult.ClickUrlFunc = listing => Tracker.MakeTrackerUrl(searchRequest.ServeUrl,string.Empty,new Dictionary<string, string>(), listing, searchResult);

            var listings = new List<Listing>();
            foreach (var listing in searchResult.Listings)
            {
                listing.ClickUrl = searchResult.ClickUrlFunc(listing);
                listings.Add(listing);
            }

            return Json(listings, JsonRequestBehavior.AllowGet);
        }
    }
}