﻿using System;
using System.IO;
using System.Net;
using System.Net.Http;
using System.Web.Mvc;
using Serilog;
using ServiceStack;

namespace Mobile.Search.Web.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index(string q)
        {
            //http://localhost:64292/search/template?templateKey=clean&keyword=audi+a4&debug=true
            var html = default(string);
            if (!string.IsNullOrEmpty(q))
            {
                // Very weird issue here I haven't figured out

                // basically this won't work if it's pointed at mobsearch.adk-mobile.com
                // the urls work fine (you can copy paste them to your browser), but the results
                // never show.  I tried on each of the 3 load balanced boxes, and it all works on each individual box
                // but on mobsearch it won't.  To fix..this just runs the template gen and search on dartmob (staging server)
                // this is a terrible solution but it works...for now..

            
                var url = "http://mobsearch.dartmob.net/Search/Template"
                    .AddQueryParam("templateKey", "clean")
                    .AddQueryParam("keyword", q)
                    .AddQueryParam("c", 10)
                    .AddQueryParam("sourceTagOverride", "adknowledge_mobile_2click_newsletter_search");
                ViewBag.Url = url;
                try
                {
                    var httpClient = new HttpClient();
                    var t = httpClient.GetStringAsync(url);
                    t.Wait();
                    html = t.Result;
                    ViewBag.ExceptionBody = "No Errors";
                }
                catch (WebException x)
                {
                    var stream = x.Response.GetResponseStream();
                    if (stream != null)
                    {
                        var streamReader = new StreamReader(stream);
                        Log.Error(x, "Error in searching: {body}", streamReader.ReadToEnd());
                    }
                }
                catch (Exception x)
                {
                    ViewBag.ExceptionBody = x.Message;
                    Log.Error(x, "Error in searching");
                }
            }

            return View(new SearchPageViewModel { Html = html});
        }

    }

    public class SearchPageViewModel
    {
        public string Html { get; set; }
        public string PixelUrl { get; set; }
        public string Query { get; set; }
    }
}