﻿using System.Linq;
using System.Web.Mvc;
using System.Web.Routing;
using Chronos;
using Mobile.Search.Shared.Extensions;
using Mobile.Search.Web.Helpers;
using ServiceStack;

namespace Mobile.Search.Web.Controllers
{
    public class InboxMobiController : Controller
    {
        // GET: InboxMobi
        public ActionResult Index(string q, string src, string uuid, string userid, string product, string pubid, string description, string view)
        {
            var ip = Request["ip"] ?? RequestHelper.GetIp(HttpContext);

            view = string.IsNullOrEmpty(view) ? "Index" : view;
            var pixelUrl =
                string.Format(
                    "http://imp.email.adk-mobile.com/install?event=WebclipOpen&uuid={0}&product={1}&pubid={2}&src={3}&view={4}",
                    uuid, product, pubid, src, view);

            var qStringDict = Request.QueryString.ToDictionary();
            qStringDict.AddOnlyIfDoesntExist("templateKey", "yahooclone");
            qStringDict.AddOnlyIfDoesntExist("keyword", q);
            qStringDict.AddOnlyIfDoesntExist("uuid", uuid);
            qStringDict.AddOnlyIfDoesntExist("src", src);
            qStringDict.AddOnlyIfDoesntExist("product", product);
            qStringDict.AddOnlyIfDoesntExist("view", view);
            qStringDict.AddOnlyIfDoesntExist("c", "3");
            qStringDict.AddOnlyIfDoesntExist("nbr", "10");
            qStringDict.AddOnlyIfDoesntExist("sourceTagOverride", "adknowledge_mobile_2click_newsletter_search");
            qStringDict.AddOnlyIfDoesntExist("strongWords", "true");
            qStringDict.AddOnlyIfDoesntExist("ip", ip);

            var html = default(string);
            if (!string.IsNullOrEmpty(q))
            {
                var typeTagSuffix = string.IsNullOrEmpty(description) ? "_webclip" : "_webclip-" + description;
                qStringDict.AddOnlyIfDoesntExist("typeTagSuffix", typeTagSuffix);
                var url = Url.Action("Template", "Search", new RouteValueDictionary(qStringDict.ToDictionary(x => x.Key, x => (object)x.Value)), "http");

                html = url.GetStringFromUrl();
            }

            view = string.IsNullOrEmpty(view) ? "Index" : view;

            return View(view,new SearchPageViewModel { Html = html, PixelUrl = pixelUrl, Query = q});
        }
    }
}