﻿using Chronos;
using Mobile.Search.Shared.Extensions;
using Mobile.Search.Web.Helpers;
using ServiceStack;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using HtmlAgilityPack;
using PagedList;


namespace Mobile.Search.Web.Controllers
{
    public class LightningController : Controller
    {
        // GET: Lightning
        public ViewResult Index(string q, string uuid, int? page, string src = "LightningBrowser")
        {
            var ip = Request["ip"] ?? RequestHelper.GetIp(HttpContext);

            TrackSearch("Search", uuid, ip, src, q);

            var html = default(string);
            if (!string.IsNullOrEmpty(q))
            {
                var qStringDict = Request.QueryString.ToDictionary();
                qStringDict.AddOnlyIfDoesntExist("templateKey", "yahooclone");
                qStringDict.AddOnlyIfDoesntExist("keyword", q);
                qStringDict.AddOnlyIfDoesntExist("uuid", uuid);
                qStringDict.AddOnlyIfDoesntExist("src", src);
                qStringDict.AddOnlyIfDoesntExist("c", "3");
                qStringDict.AddOnlyIfDoesntExist("nbr", "75");
                qStringDict.AddOnlyIfDoesntExist("sourceTagOverride", "adknowledge_mobile_2click_e_search");
                qStringDict.AddOnlyIfDoesntExist("typeTagSuffix", "_lb");
                qStringDict.AddOnlyIfDoesntExist("ip", ip);
                var url = Url.Action("Template", "Search", new RouteValueDictionary(qStringDict.ToDictionary(x => x.Key, x => (object)x.Value)), "http");
                html = url.GetStringFromUrl();

                HtmlDocument doc = new HtmlDocument();
                doc.LoadHtml(html);

                HtmlNodeCollection nodes = doc.DocumentNode.SelectNodes("//div[contains(@class,'contain-box')]");
                var totalNodes = nodes.Count;
                System.Diagnostics.Debug.WriteLine("TOTAL NODES IS" + totalNodes);

                int pageSize = 10;
                int pageNumber = (page ?? 1);
                ViewBag.searchTerm = q;
                return View(nodes.ToPagedList(pageNumber, pageSize));
            }

            else {
                return View();
            }
            //return View("Index", new SearchPageViewModel { Html = html, Query = q });
        }

        public ViewResult Index2(string q, string uuid, int? page, string src = "LightningBrowser")
        {
            var ip = Request["ip"] ?? RequestHelper.GetIp(HttpContext);

            TrackSearch("Search", uuid, ip, src, q);

            var html = default(string);
            if (!string.IsNullOrEmpty(q))
            {
                var qStringDict = Request.QueryString.ToDictionary();
                qStringDict.AddOnlyIfDoesntExist("templateKey", "yahooclone");
                qStringDict.AddOnlyIfDoesntExist("keyword", q);
                qStringDict.AddOnlyIfDoesntExist("uuid", uuid);
                qStringDict.AddOnlyIfDoesntExist("src", src);
                qStringDict.AddOnlyIfDoesntExist("c", "3");
                qStringDict.AddOnlyIfDoesntExist("nbr", "75");
                qStringDict.AddOnlyIfDoesntExist("sourceTagOverride", "adknowledge_mobile_2click_e_search");
                qStringDict.AddOnlyIfDoesntExist("typeTagSuffix", "_lb");
                qStringDict.AddOnlyIfDoesntExist("ip", ip);
                var url = Url.Action("Template", "Search", new RouteValueDictionary(qStringDict.ToDictionary(x => x.Key, x => (object)x.Value)), "http");
                html = url.GetStringFromUrl();

                HtmlDocument doc = new HtmlDocument();
                doc.LoadHtml(html);

                HtmlNodeCollection nodes = doc.DocumentNode.SelectNodes("//div[contains(@class,'contain-box')]");
                var totalNodes = nodes.Count;
                System.Diagnostics.Debug.WriteLine("TOTAL NODES IS" + totalNodes);

                int pageSize = 10;
                int pageNumber = (page ?? 1);
                ViewBag.searchTerm = q;
                return View(nodes.ToPagedList(pageNumber, pageSize));
            }

            else
            {
                return View();
            }
            //return View("Index", new SearchPageViewModel { Html = html, Query = q });
        }

        // GET: Lightning
        public ActionResult Horoscope(string q, string uuid, string src = "AstroBrowser")
        {
            var ip = Request["ip"] ?? RequestHelper.GetIp(HttpContext);

            TrackSearch("Search", uuid, ip, src, q);

            var html = default(string);
            if (!string.IsNullOrEmpty(q))
            {
                var qStringDict = Request.QueryString.ToDictionary();
                qStringDict.AddOnlyIfDoesntExist("templateKey", "yahooclone");
                qStringDict.AddOnlyIfDoesntExist("keyword", q);
                qStringDict.AddOnlyIfDoesntExist("uuid", uuid);
                qStringDict.AddOnlyIfDoesntExist("src", src);
                qStringDict.AddOnlyIfDoesntExist("c", "3");
                qStringDict.AddOnlyIfDoesntExist("nbr", "10");
                qStringDict.AddOnlyIfDoesntExist("sourceTagOverride", "adknowledge_mobile_2click_e_search");
                qStringDict.AddOnlyIfDoesntExist("typeTagSuffix", "_ab");
                qStringDict.AddOnlyIfDoesntExist("ip", ip);
                var url = Url.Action("Template", "Search", new RouteValueDictionary(qStringDict.ToDictionary(x => x.Key, x => (object)x.Value)), "http");
                html = url.GetStringFromUrl();
               
            }

            var dateAndTime = DateTime.Now;
            var date = dateAndTime.Date;
            ViewBag.today = date.ToString();
            return View("Horoscope", new SearchPageViewModel { Html = html, Query = q });
        }

        public ActionResult Discounts(string q, string uuid, string src = "DiscountsBrowser")
        {
            var ip = Request["ip"] ?? RequestHelper.GetIp(HttpContext);

            TrackSearch("Search", uuid, ip, src, q);

            var html = default(string);
            if (!string.IsNullOrEmpty(q))
            {
                var qStringDict = Request.QueryString.ToDictionary();
                qStringDict.AddOnlyIfDoesntExist("templateKey", "yahooclone");
                qStringDict.AddOnlyIfDoesntExist("keyword", q);
                qStringDict.AddOnlyIfDoesntExist("uuid", uuid);
                qStringDict.AddOnlyIfDoesntExist("src", src);
                qStringDict.AddOnlyIfDoesntExist("c", "3");
                qStringDict.AddOnlyIfDoesntExist("nbr", "10");
                qStringDict.AddOnlyIfDoesntExist("sourceTagOverride", "adknowledge_mobile_2click_e_search");
                qStringDict.AddOnlyIfDoesntExist("typeTagSuffix", "_db");
                qStringDict.AddOnlyIfDoesntExist("ip", ip);
                var url = Url.Action("Template", "Search", new RouteValueDictionary(qStringDict.ToDictionary(x => x.Key, x => (object)x.Value)), "http");
                html = url.GetStringFromUrl();
            }

            var dateAndTime = DateTime.Now;
            var date = dateAndTime.Date;
            ViewBag.today = date.ToString();
            return View("Discounts", new SearchPageViewModel { Html = html, Query = q });
        }

        public ActionResult Bible(string q, string uuid, string src = "BibleBrowser")
        {
            var ip = Request["ip"] ?? RequestHelper.GetIp(HttpContext);

            TrackSearch("Search", uuid, ip, src, q);

            var html = default(string);
            if (!string.IsNullOrEmpty(q))
            {
                var qStringDict = Request.QueryString.ToDictionary();
                qStringDict.AddOnlyIfDoesntExist("templateKey", "yahooclone");
                qStringDict.AddOnlyIfDoesntExist("keyword", q);
                qStringDict.AddOnlyIfDoesntExist("uuid", uuid);
                qStringDict.AddOnlyIfDoesntExist("src", src);
                qStringDict.AddOnlyIfDoesntExist("c", "3");
                qStringDict.AddOnlyIfDoesntExist("nbr", "10");
                qStringDict.AddOnlyIfDoesntExist("sourceTagOverride", "adknowledge_mobile_2click_e_search");
                qStringDict.AddOnlyIfDoesntExist("typeTagSuffix", "_bb");
                qStringDict.AddOnlyIfDoesntExist("ip", ip);
                var url = Url.Action("Template", "Search", new RouteValueDictionary(qStringDict.ToDictionary(x => x.Key, x => (object)x.Value)), "http");
                html = url.GetStringFromUrl();
            }

            var dateAndTime = DateTime.Now;
            var date = dateAndTime.Date;
            ViewBag.today = date.ToString();
            return View("Bible", new SearchPageViewModel { Html = html, Query = q });
        }

        public static void TrackSearch(string e, string uuid, string remoteIp, string src, string q)
        {
            System.Diagnostics.Debug.WriteLine("IN TRACK SEARCH ");
            var trackingUrl = string.Format(
                "http://imp.email.adk-mobile.com/install?event=Search&uuid={0}&remoteIp={1}&src={2}&searchQuery={3}",
                uuid, remoteIp, src, q);
            var task = MakeAsyncRequest(trackingUrl, "text/html");
            // also send searches to new app events table (remove above soon)
            var trackingUrlEvent = string.Format(
                "http://imp.email.adk-mobile.com/appevent?event=Search&uuid={0}&remoteIp={1}&src={2}&searchQuery={3}",
                uuid, remoteIp, src, q);
            var taskUrlEvent = MakeAsyncRequest(trackingUrlEvent, "text/html");
          
        }

        public static Task<string> MakeAsyncRequest(string url, string contentType)
        {
            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);
            request.ContentType = contentType;
            request.Method = WebRequestMethods.Http.Get;
            request.Timeout = 20000;
            request.Proxy = null;

            Task<WebResponse> task = Task.Factory.FromAsync(
                request.BeginGetResponse,
                asyncResult => request.EndGetResponse(asyncResult),
                (object)null);

            return task.ContinueWith(t => ReadStreamFromResponse(t.Result));
        }

        private static string ReadStreamFromResponse(WebResponse response)
        {
            using (Stream responseStream = response.GetResponseStream())
            using (StreamReader sr = new StreamReader(responseStream))
            {
                string strContent = sr.ReadToEnd();
                return strContent;
            }
        }
    }
}