﻿using System.Web.Mvc;
using Mobile.Search.Providers;
using Mobile.Search.Web.Helpers;

namespace Mobile.Search.Web.Controllers
{
    public class UserStatsController : Controller
    {
        // GET: UserStats
        public ActionResult Index(string uuid)
        {
            return Json(RedisHelper.GetLastKeywords(uuid), JsonRequestBehavior.AllowGet);
        }

        public ActionResult UserRelatedKeywords(string uuid)
        {
            var result = new
            {
                opens_related = KeywordBlockHelper.GetRelatedLastOpenedKeywords(uuid),
                clicks_related = KeywordBlockHelper.GetRelatedLastClickedKeywords(uuid),
                related = KeywordBlockHelper.GetKeywordsForUser(uuid)
            };
            return Json(result, JsonRequestBehavior.AllowGet);
        }

        public ActionResult RelatedKeywords(string keyword)
        {
             var result = new
            {
                related = YahooProvider.GetRelatedKeywords(keyword)
            };
            return Json(result, JsonRequestBehavior.AllowGet);
        }
    }
}