﻿using System;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.Mvc;
using ServiceStack;

namespace Mobile.Search.Web.Extensions
{
    public static class HtmlExtensions
    {
        public static HtmlString BoldQuery(this string text, string queryText)
        {
            var words = queryText.Split(new[] {' '})
                .Select(x => x.ToLower())
                .ToArray();

            if (queryText.ContainsAny(words))
            {
                foreach (var word in words)
                {
                    text = Regex.Replace(text, @"\b" + word + @"\b", delegate(Match match)
                    {
                        string v = match.ToString();
                        return "<strong>" + v + "</strong>";
                    },RegexOptions.IgnoreCase);

                }
            }
            return new HtmlString(text);
        }

        public static HtmlString GetStateClass(this HtmlHelper helper, string activeKeyword, string keyword)
        {
            activeKeyword = activeKeyword.Replace(" ", "+");
            keyword = keyword.Replace(" ", "+");

            if (String.Equals(activeKeyword, keyword, StringComparison.CurrentCultureIgnoreCase))
            {
                return new HtmlString("active");
            }
            return new HtmlString("inactive");
        }
    }
}