﻿using Quartz;
using Quartz.Impl;
using Quartz.Impl.Matchers;

namespace Mobile.Search.Web.Helpers
{
    public class JobScheduler
    {
        public static void Start()
        {
            IScheduler scheduler = StdSchedulerFactory.GetDefaultScheduler();
            scheduler.ListenerManager.AddJobListener(new JobListener(), GroupMatcher<JobKey>.AnyGroup());
            scheduler.Start();

            IJobDetail job = JobBuilder.Create<PublishCloudWatchMetricsJob>().Build();
            
            ITrigger trigger = TriggerBuilder.Create()
                .WithSimpleSchedule(s =>
                    s.WithIntervalInSeconds(20)
                        .RepeatForever())
                .Build();

            scheduler.ScheduleJob(job, trigger);
        }
    }
}