﻿using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;
using Mobile.Search.Providers;

namespace Mobile.Search.Web.Helpers
{
    public class KeywordBlockHelper
    {
        public static List<string> GetRelatedLastClickedKeywords(string uuid)
        {
            var dict = RedisHelper.GetLastKeywords(uuid);

            var list = new List<string>();
            if (dict.ContainsKey("last_clicked_keyword"))
            {
                list.AddRange(YahooProvider.GetRelatedKeywords(dict["last_clicked_keyword"].Replace("+", " ")));
            }
            return list;
        }

        public static List<string> GetRelatedLastOpenedKeywords(string uuid)
        {
            var dict = RedisHelper.GetLastKeywords(uuid);
            var list = new List<string>();
            if (dict.ContainsKey("last_opened_keyword"))
            {
                list.AddRange(YahooProvider.GetRelatedKeywords(dict["last_opened_keyword"].Replace("+", " ")));
            }
            return list;
        }
        public static List<string> GetKeywordsForUser(string uuid, int keywordCount =3)
        {
            var keywords = new List<string>();

            keywords.AddRange(GetRelatedLastClickedKeywords(uuid));

            if (keywords.Count >= keywordCount)
            {
                return keywords.Take(keywordCount).ToList();
            }

            keywords.AddRange(GetRelatedLastOpenedKeywords(uuid));
           
            if (keywords.Count >= keywordCount)
            {
                return keywords.Take(keywordCount).ToList();
            }

            keywords.AddRange(TopKeywordsCache.Instance.TopKeywords);

            return keywords.Take(keywordCount).ToList();
        }

    }
}