﻿using System;
using System.Collections.Generic;
using Mobile.Search.Shared.Models;

namespace Mobile.Search.Web.Models
{
    public class KeywordBlockVariables : TemplateVariablesBase
    {
        public KeywordBlockKeyword Keyword1 { get; set; }
        public KeywordBlockKeyword Keyword2 { get; set; }
        public KeywordBlockKeyword Keyword3 { get; set; }
        public KeywordBlockKeyword Keyword4 { get; set; }
        public KeywordBlockKeyword Keyword5 { get; set; }
        public KeywordBlockKeyword Keyword6 { get; set; }
    }

    public class KeywordBlockKeyword
    {
        public string Keyword { get; set; }

        public string Listing1ImageUrl { get; set; }
        public string Listing1Title { get; set; }
        public string Listing1Description { get; set; }
        public string Listing1ClickUrl { get; set; }
        public string Listing1Advertiser { get; set; }
        public string Listing1FaviconUrl { get; set; }
        public string Listing1MerchRatingNumber { get; set; }
        public string Listing1MerchRatingUrl { get; set; }
        public string Listing1PhoneNumber { get; set; }

        // === Yahoo! API Extensions Update 2017-10-11 === //

        // 1. Callout Extensions
        public string Listing1CalloutAnnotation { get; set; }

        // 2. Review Extensions
        public string Listing1ReviewSource { get; set; }
        public string Listing1ReviewText { get; set; }

        // 3. 4th Line Annotation
        public string Listing1Ad4thLine { get; set; }

        // 4. Top Ad Annotation
        public string Listing1HasTopAdAnnotation { get; set; }
        public string Listing1TopAdDomain { get; set; }
        public string Listing1TopAdClicks { get; set; }

        // 5. Security Badge
        public string Listing1SecurityProvider { get; set; }

        // 6. Brand Annotation
        public string Listing1AdOfficialBrand { get; set; }

        // 7. Smart Ad Annotation
        public string Listing1SmartAdAnnotation { get; set; }

        public string Listing2ImageUrl { get; set; }
        public string Listing2Title { get; set; }
        public string Listing2Description { get; set; }
        public string Listing2ClickUrl { get; set; }
        public string Listing2Advertiser { get; set; }
        public string Listing2FaviconUrl { get; set; }
        public string Listing2MerchRatingNumber { get; set; }
        public string Listing2MerchRatingUrl { get; set; }
        public string Listing2PhoneNumber { get; set; }

        // === Yahoo! API Extensions Update 2017-10-11 === //

        // 1. Callout Extensions
        public string Listing2CalloutAnnotation { get; set; }

        // 2. Review Extensions
        public string Listing2ReviewSource { get; set; }
        public string Listing2ReviewText { get; set; }

        // 3. 4th Line Annotation
        public string Listing2Ad4thLine { get; set; }

        // 4. Top Ad Annotation
        public string Listing2HasTopAdAnnotation { get; set; }
        public string Listing2TopAdDomain { get; set; }
        public string Listing2TopAdClicks { get; set; }

        // 5. Security Badge
        public string Listing2SecurityProvider { get; set; }

        // 6. Brand Annotation
        public string Listing2AdOfficialBrand { get; set; }

        // 7. Smart Ad Annotation
        public string Listing2SmartAdAnnotation { get; set; }
    }
    public class TemplateVariablesBase
    {
        public Func<string, string> TemplateUrl { get; set; }
        public Func<string, string> WrapUrl { get; set; }
        public string Hotspot { get; set; }
        public string Subject { get; set; }
        public string Footer { get; set; }
        public string Ip { get; set; }
        public string Uuid { get; set; }
        public string EmailId { get; set; }
        public string TemplateName { get; set; }
        public string UserClass { get; set; }
        public string OfferId { get; set; }
        public string Product { get; set; }
        public string DateString { get; set; }
        public string Name { get; set; }
    }

    public class TemplateVariables :TemplateVariablesBase
    {
        public string Keyword { get; set; }

        public List<ListingTemplateVariables> Listings { get; set; }
        public ListingTemplateVariables Listing1 { get; set; }
        public ListingTemplateVariables Listing2 { get; set; }
        public ListingTemplateVariables Listing3 { get; set; }
        public ListingTemplateVariables Listing4 { get; set; }
        public ListingTemplateVariables Listing5 { get; set; }

      // === LISTING 1 === //
        public string Listing1ImageUrl { get; set; }
        public string Listing1Title { get; set; }
        public string Listing1LongTitle { get; set; }
        public string Listing1Description { get; set; }
        public string Listing1Advertiser { get; set; }
        public string Listing1AdvertiserUrl { get; set; }
        public string Listing1ListingUrl { get; set; }
        public string Listing1ClickUrl { get; set; }
        public string Listing1FaviconUrl { get; set; }
        public string Listing1MerchRatingNumber { get; set; }
        public string Listing1MerchRatingUrl { get; set; }
        public string Listing1PhoneNumber { get; set; }

        // === Yahoo! API Extensions Update 2017-10-11 === //

        // 1. Callout Extensions
        public string Listing1CalloutAnnotation { get; set; }

        // 2. Review Extensions
        public string Listing1ReviewSource { get; set; }
        public string Listing1ReviewText { get; set; }

        // 3. 4th Line Annotation
        public string Listing1Ad4thLine { get; set; }

        // 4. Top Ad Annotation
        public string Listing1HasTopAdAnnotation { get; set; }
        public string Listing1TopAdDomain { get; set; }
        public string Listing1TopAdClicks { get; set; }

        // 5. Security Badge
        public string Listing1SecurityProvider { get; set; }

        // 6. Brand Annotation
        public string Listing1AdOfficialBrand { get; set; }

        // 7. Smart Ad Annotation
        public string Listing1SmartAdAnnotation { get; set; }

        // === LISTING 2 === //
        public string Listing2ImageUrl { get; set; }
        public string Listing2Title { get; set; }
        public string Listing2LongTitle { get; set; }
        public string Listing2Description { get; set; }
        public string Listing2Advertiser { get; set; }
        public string Listing2AdvertiserUrl { get; set; }
        public string Listing2ListingUrl { get; set; }
        public string Listing2ClickUrl { get; set; }
        public string Listing2FaviconUrl { get; set; }
        public string Listing2MerchRatingNumber { get; set; }
        public string Listing2MerchRatingUrl { get; set; }
        public string Listing2PhoneNumber { get; set; }

        // === Yahoo! API Extensions Update 2017-10-11 === //

        // 1. Callout Extensions
        public string Listing2CalloutAnnotation { get; set; }

        // 2. Review Extensions
        public string Listing2ReviewSource { get; set; }
        public string Listing2ReviewText { get; set; }

        // 3. 4th Line Annotation
        public string Listing2Ad4thLine { get; set; }

        // 4. Top Ad Annotation
        public string Listing2HasTopAdAnnotation { get; set; }
        public string Listing2TopAdDomain { get; set; }
        public string Listing2TopAdClicks { get; set; }

        // 5. Security Badge
        public string Listing2SecurityProvider { get; set; }

        // 6. Brand Annotation
        public string Listing2AdOfficialBrand { get; set; }

        // 7. Smart Ad Annotation
        public string Listing2SmartAdAnnotation { get; set; }

        // === LISTING 3 === //
        public string Listing3ImageUrl { get; set; }
        public string Listing3Title { get; set; }
        public string Listing3LongTitle { get; set; }
        public string Listing3Description { get; set; }
        public string Listing3Advertiser { get; set; }
        public string Listing3AdvertiserUrl { get; set; }
        public string Listing3ListingUrl { get; set; }
        public string Listing3ClickUrl { get; set; }
        public string Listing3FaviconUrl { get; set; }
        public string Listing3MerchRatingNumber { get; set; }
        public string Listing3MerchRatingUrl { get; set; }
        public string Listing3PhoneNumber { get; set; }

        // === Yahoo! API Extensions Update 2017-10-11 === //

        // 1. Callout Extensions
        public string Listing3CalloutAnnotation { get; set; }

        // 2. Review Extensions
        public string Listing3ReviewSource { get; set; }
        public string Listing3ReviewText { get; set; }

        // 3. 4th Line Annotation
        public string Listing3Ad4thLine { get; set; }

        // 4. Top Ad Annotation
        public string Listing3HasTopAdAnnotation { get; set; }
        public string Listing3TopAdDomain { get; set; }
        public string Listing3TopAdClicks { get; set; }

        // 5. Security Badge
        public string Listing3SecurityProvider { get; set; }

        // 6. Brand Annotation
        public string Listing3AdOfficialBrand { get; set; }

        // 7. Smart Ad Annotation
        public string Listing3SmartAdAnnotation { get; set; }

        // === LISTING 4 === //
        public string Listing4ImageUrl { get; set; }
        public string Listing4Title { get; set; }
        public string Listing4LongTitle { get; set; }
        public string Listing4Description { get; set; }
        public string Listing4Advertiser { get; set; }
        public string Listing4AdvertiserUrl { get; set; }
        public string Listing4ListingUrl { get; set; }
        public string Listing4ClickUrl { get; set; }
        public string Listing4FaviconUrl { get; set; }
        public string Listing4MerchRatingNumber { get; set; }
        public string Listing4MerchRatingUrl { get; set; }
        public string Listing4PhoneNumber { get; set; }

        // === Yahoo! API Extensions Update 2017-10-11 === //

        // 1. Callout Extensions
        public string Listing4CalloutAnnotation { get; set; }

        // 2. Review Extensions
        public string Listing4ReviewSource { get; set; }
        public string Listing4ReviewText { get; set; }

        // 3. 4th Line Annotation
        public string Listing4Ad4thLine { get; set; }

        // 4. Top Ad Annotation
        public string Listing4HasTopAdAnnotation { get; set; }
        public string Listing4TopAdDomain { get; set; }
        public string Listing4TopAdClicks { get; set; }

        // 5. Security Badge
        public string Listing4SecurityProvider { get; set; }

        // 6. Brand Annotation
        public string Listing4AdOfficialBrand { get; set; }

        // 7. Smart Ad Annotation
        public string Listing4SmartAdAnnotation { get; set; }

        // === LISTING 5 === //
        public string Listing5ImageUrl { get; set; }
        public string Listing5Title { get; set; }
        public string Listing5LongTitle { get; set; }
        public string Listing5Description { get; set; }
        public string Listing5Advertiser { get; set; }
        public string Listing5AdvertiserUrl { get; set; }
        public string Listing5ListingUrl { get; set; }
        public string Listing5ClickUrl { get; set; }
        public string Listing5FaviconUrl { get; set; }
        public string Listing5MerchRatingNumber { get; set; }
        public string Listing5MerchRatingUrl { get; set; }
        public string Listing5PhoneNumber { get; set; }

        // === Yahoo! API Extensions Update 2017-10-11 === //

        // 1. Callout Extensions
        public string Listing5CalloutAnnotation { get; set; }

        // 2. Review Extensions
        public string Listing5ReviewSource { get; set; }
        public string Listing5ReviewText { get; set; }

        // 3. 4th Line Annotation
        public string Listing5Ad4thLine { get; set; }

        // 4. Top Ad Annotation
        public string Listing5HasTopAdAnnotation { get; set; }
        public string Listing5TopAdDomain { get; set; }
        public string Listing5TopAdClicks { get; set; }

        // 5. Security Badge
        public string Listing5SecurityProvider { get; set; }

        // 6. Brand Annotation
        public string Listing5AdOfficialBrand { get; set; }

        // 7. Smart Ad Annotation
        public string Listing5SmartAdAnnotation { get; set; }

        // === //

        public List<IndeedListingTemplateVariables> IndeedListings { get; set; }
        public IndeedListingTemplateVariables IndeedListing1 { get; set; }
        public IndeedListingTemplateVariables IndeedListing2 { get; set; }
        public IndeedListingTemplateVariables IndeedListing3 { get; set; }
        public IndeedListingTemplateVariables IndeedListing4 { get; set; }
        public IndeedListingTemplateVariables IndeedListing5 { get; set; }
        public IndeedListingTemplateVariables IndeedListing6 { get; set; }
        public IndeedListingTemplateVariables IndeedListing7 { get; set; }
        public IndeedListingTemplateVariables IndeedListing8 { get; set; }
        public IndeedListingTemplateVariables IndeedListing9 { get; set; }
        public IndeedListingTemplateVariables IndeedListing10 { get; set; }

        public string IndeedListing1Title { get; set; }
        public string IndeedListing1Description { get; set; }
        public string IndeedListing1Advertiser { get; set; }
        public string IndeedListing1AdvertiserUrl { get; set; }
        public string IndeedListing1ListingUrl { get; set; }
        public string IndeedListing1ClickUrl { get; set; }

        public string IndeedListing2Title { get; set; }
        public string IndeedListing2Description { get; set; }
        public string IndeedListing2Advertiser { get; set; }
        public string IndeedListing2AdvertiserUrl { get; set; }
        public string IndeedListing2ListingUrl { get; set; }
        public string IndeedListing2ClickUrl { get; set; }

        public string IndeedListing3Title { get; set; }
        public string IndeedListing3Description { get; set; }
        public string IndeedListing3Advertiser { get; set; }
        public string IndeedListing3AdvertiserUrl { get; set; }
        public string IndeedListing3ListingUrl { get; set; }
        public string IndeedListing3ClickUrl { get; set; }

        public string IndeedListing4Title { get; set; }
        public string IndeedListing4Description { get; set; }
        public string IndeedListing4Advertiser { get; set; }
        public string IndeedListing4AdvertiserUrl { get; set; }
        public string IndeedListing4ListingUrl { get; set; }
        public string IndeedListing4ClickUrl { get; set; }

        public string IndeedListing5Title { get; set; }
        public string IndeedListing5Description { get; set; }
        public string IndeedListing5Advertiser { get; set; }
        public string IndeedListing5AdvertiserUrl { get; set; }
        public string IndeedListing5ListingUrl { get; set; }
        public string IndeedListing5ClickUrl { get; set; }

        public string IndeedListing6Title { get; set; }
        public string IndeedListing6Description { get; set; }
        public string IndeedListing6Advertiser { get; set; }
        public string IndeedListing6AdvertiserUrl { get; set; }
        public string IndeedListing6ListingUrl { get; set; }
        public string IndeedListing6ClickUrl { get; set; }

        public string IndeedListing7Title { get; set; }
        public string IndeedListing7Description { get; set; }
        public string IndeedListing7Advertiser { get; set; }
        public string IndeedListing7AdvertiserUrl { get; set; }
        public string IndeedListing7ListingUrl { get; set; }
        public string IndeedListing7ClickUrl { get; set; }

        public string IndeedListing8Title { get; set; }
        public string IndeedListing8Description { get; set; }
        public string IndeedListing8Advertiser { get; set; }
        public string IndeedListing8AdvertiserUrl { get; set; }
        public string IndeedListing8ListingUrl { get; set; }
        public string IndeedListing8ClickUrl { get; set; }

        public string IndeedListing9Title { get; set; }
        public string IndeedListing9Description { get; set; }
        public string IndeedListing9Advertiser { get; set; }
        public string IndeedListing9AdvertiserUrl { get; set; }
        public string IndeedListing9ListingUrl { get; set; }
        public string IndeedListing9ClickUrl { get; set; }

        public string IndeedListing10Title { get; set; }
        public string IndeedListing10Description { get; set; }
        public string IndeedListing10Advertiser { get; set; }
        public string IndeedListing10AdvertiserUrl { get; set; }
        public string IndeedListing10ListingUrl { get; set; }
        public string IndeedListing10ClickUrl { get; set; }


        public List<TaboolaListingTemplateVariables> TaboolaListings { get; set; }
        public TaboolaListingTemplateVariables TaboolaListing1 { get; set; }
        public TaboolaListingTemplateVariables TaboolaListing2 { get; set; }
        public TaboolaListingTemplateVariables TaboolaListing3 { get; set; }
        public TaboolaListingTemplateVariables TaboolaListing4 { get; set; }
        public TaboolaListingTemplateVariables TaboolaListing5 { get; set; }
        public TaboolaListingTemplateVariables TaboolaListing6 { get; set; }
        public TaboolaListingTemplateVariables TaboolaListing7 { get; set; }
        public TaboolaListingTemplateVariables TaboolaListing8 { get; set; }
        public TaboolaListingTemplateVariables TaboolaListing9 { get; set; }
        public TaboolaListingTemplateVariables TaboolaListing10 { get; set; }

        public string TaboolaListing1Title { get; set; }
        public string TaboolaListing1Description { get; set; }
        public string TaboolaListing1Advertiser { get; set; }
        public string TaboolaListing1AdvertiserUrl { get; set; }
        public string TaboolaListing1ListingUrl { get; set; }
        public string TaboolaListing1ClickUrl { get; set; }

        public string TaboolaListing2Title { get; set; }
        public string TaboolaListing2Description { get; set; }
        public string TaboolaListing2Advertiser { get; set; }
        public string TaboolaListing2AdvertiserUrl { get; set; }
        public string TaboolaListing2ListingUrl { get; set; }
        public string TaboolaListing2ClickUrl { get; set; }

        public string TaboolaListing3Title { get; set; }
        public string TaboolaListing3Description { get; set; }
        public string TaboolaListing3Advertiser { get; set; }
        public string TaboolaListing3AdvertiserUrl { get; set; }
        public string TaboolaListing3ListingUrl { get; set; }
        public string TaboolaListing3ClickUrl { get; set; }

        public string TaboolaListing4Title { get; set; }
        public string TaboolaListing4Description { get; set; }
        public string TaboolaListing4Advertiser { get; set; }
        public string TaboolaListing4AdvertiserUrl { get; set; }
        public string TaboolaListing4ListingUrl { get; set; }
        public string TaboolaListing4ClickUrl { get; set; }

        public string TaboolaListing5Title { get; set; }
        public string TaboolaListing5Description { get; set; }
        public string TaboolaListing5Advertiser { get; set; }
        public string TaboolaListing5AdvertiserUrl { get; set; }
        public string TaboolaListing5ListingUrl { get; set; }
        public string TaboolaListing5ClickUrl { get; set; }

        public string TaboolaListing6Title { get; set; }
        public string TaboolaListing6Description { get; set; }
        public string TaboolaListing6Advertiser { get; set; }
        public string TaboolaListing6AdvertiserUrl { get; set; }
        public string TaboolaListing6ListingUrl { get; set; }
        public string TaboolaListing6ClickUrl { get; set; }

        public string TaboolaListing7Title { get; set; }
        public string TaboolaListing7Description { get; set; }
        public string TaboolaListing7Advertiser { get; set; }
        public string TaboolaListing7AdvertiserUrl { get; set; }
        public string TaboolaListing7ListingUrl { get; set; }
        public string TaboolaListing7ClickUrl { get; set; }

        public string TaboolaListing8Title { get; set; }
        public string TaboolaListing8Description { get; set; }
        public string TaboolaListing8Advertiser { get; set; }
        public string TaboolaListing8AdvertiserUrl { get; set; }
        public string TaboolaListing8ListingUrl { get; set; }
        public string TaboolaListing8ClickUrl { get; set; }

        public string TaboolaListing9Title { get; set; }
        public string TaboolaListing9Description { get; set; }
        public string TaboolaListing9Advertiser { get; set; }
        public string TaboolaListing9AdvertiserUrl { get; set; }
        public string TaboolaListing9ListingUrl { get; set; }
        public string TaboolaListing9ClickUrl { get; set; }

        public string TaboolaListing10Title { get; set; }
        public string TaboolaListing10Description { get; set; }
        public string TaboolaListing10Advertiser { get; set; }
        public string TaboolaListing10AdvertiserUrl { get; set; }
        public string TaboolaListing10ListingUrl { get; set; }
        public string TaboolaListing10ClickUrl { get; set; }
    }

    public class ListingTemplateVariables
    {
        public int ListingIndex { get; set; }
        public bool BiddedListing { get; set; }
        public int Rank { get; set; }
        public string Title { get; set; }
        public string LongTitle { get; set; }
        public string Description { get; set; }
        public string Advertiser { get; set; }
        public string AdvertiserUrl { get; set; }
        public string ListingUrl { get; set; }
        public string ClickUrl { get; set; }
        public string FaviconUrl { get; set; }
        public string ImageUrl { get; set; }
        public string ThumbnailImageUrl { get; set; }
        public string MerchRatingNumber { get; set; }
        public string MerchRatingUrl { get; set; }
        public string PhoneNumber { get; set; }

        // === Yahoo! API Extensions Update 2017-10-11 === //

        // 1. Callout Extensions
        public string CalloutAnnotation { get; set; }

        // 2. Review Extensions
        public string ReviewSource { get; set; }
        public string ReviewText { get; set; }

        // 3. 4th Line Annotation
        public string Ad4thLine { get; set; }

        // 4. Top Ad Annotation
        public string HasTopAdAnnotation { get; set; }
        public string TopAdDomain { get; set; }
        public string TopAdClicks { get; set; }

        // 5. Security Badge
        public string SecurityProvider { get; set; }

        // 6. Brand Annotation
        public string AdOfficialBrand { get; set; }

        // 7. Smart Ad Annotation
        public string SmartAdAnnotation { get; set; }

        // === //

        public int DisplaySizePercentage { get; set; }

        public List<SiteLink> SiteLinks { get; set; }
        public SiteLink SiteLink1 { get; set; }
        public SiteLink SiteLink2 { get; set; }
        public SiteLink SiteLink3 { get; set; }
        public SiteLink SiteLink4 { get; set; }

        public class SiteLink
        {
            public int SiteLinkIndex { get; set; }
            public string Text { get; set; }
            public string Url { get; set; }
            public string ClickUrl { get; set; }
        }
    }

    public class IndeedListingTemplateVariables
    {
        public int ListingIndex { get; set; }
        public int Rank { get; set; }
        public string Title { get; set; }
        public string Description { get; set; }
        public string Advertiser { get; set; }
        public string AdvertiserUrl { get; set; }
        public string ListingUrl { get; set; }
        public string ClickUrl { get; set; }
    }

    public class TaboolaListingTemplateVariables
    {
        public int ListingIndex { get; set; }
        public int Rank { get; set; }
        public string Title { get; set; }
        public string Description { get; set; }
        public string Advertiser { get; set; }
        public string AdvertiserUrl { get; set; }
        public string ListingUrl { get; set; }
        public string ClickUrl { get; set; }
        public string ThumbnailImageUrl { get; set; }
    }
}